package cn.iocoder.yudao.module.llm.service.label;

import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.label.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.label.LabelDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.label.LabelMapper;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.LABEL_NOT_EXISTS;

/**
 * 标签管理 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class LabelServiceImpl implements LabelService {

    @Resource
    private LabelMapper labelMapper;

    @Override
    public Long createLabel(LabelSaveReqVO createReqVO) {
        // 插入
        LabelDO label = BeanUtils.toBean(createReqVO, LabelDO.class);
        labelMapper.insert(label);
        // 返回
        return label.getId();
    }

    @Override
    public void updateLabel(LabelSaveReqVO updateReqVO) {
        // 校验存在
        validateLabelExists(updateReqVO.getId());
        // 更新
        LabelDO updateObj = BeanUtils.toBean(updateReqVO, LabelDO.class);
        labelMapper.updateById(updateObj);
    }

    @Override
    public void deleteLabel(Long id) {
        // 校验存在
        validateLabelExists(id);
        // 删除
        labelMapper.deleteById(id);
    }

    private void validateLabelExists(Long id) {
        if (labelMapper.selectById(id) == null) {
            throw exception(LABEL_NOT_EXISTS);
        }
    }

    @Override
    public LabelDO getLabel(Long id) {
        return labelMapper.selectById(id);
    }

    @Override
    public PageResult<LabelDO> getLabelPage(LabelPageReqVO pageReqVO) {
        return labelMapper.selectPage(pageReqVO);
    }

}